                          
clear: lda #07fh                          
       sta 01h
       lda #00h
       sta 00h
       tay
       ldx #020h
       
cloop: sta (00h),y
       dey
       bne cloop
       dec 01h
       dex
       bne cloop
       rts
                          
                          
                          
                          
                          
                          
                          ;NES Play ASM file


;K. Horton
;For use with HardNES, the hardware .NSF player
;Last Modified: 7/16/99


read_add:    .equ 04000h
 
songno:      .equ 000h
tuneno:      .equ 000h

max_songs:   .equ 008h

;memory map 
;
;0000-1fffh - system RAM
;2000-4fffh - not used (cannot be used due to reg. addresses)
;5000-5f7fh - control ROM
;5f80-5fefh - control RAM
;5ff0h      - timer, low byte
;5ff1h      - timer, high byte
;5ff2h      - memory lock
;5ff3h      - memory lock
;5ff4h      - LCD write address (RS=0)
;5ff5h      - LCD write address (RS=1)
;5ff6h (W)  - reset IRQ flag
;5ff6h (R)  - bit 7- ACK for card, 6- data
;5ff7h      - inputs also resets ack for card
;5ff8-5fffh - bankswitch control
;6000-7fffh - SRAM emulation
;8000-fffbh - PRG ROM emulation
;fffc-ffffh - reset and IRQ vectors 
 
 .org 00000h 

zp_add:      .block 2
zp_add2:     .block 2

 .org 01000h

card_buf:    .block 130
card_temp:   .block 1
card_temp2:  .block 1
card_xor:    .block 1
x_temp:      .block 1
card_add:    .block 2
card_img:    .block 5 ;for card 5A,52,5C,5D,00


 .org 04e00h

mul0:        .block 1
mul1:        .block 1
mul2:        .block 1
mul3:        .block 1

bcd_out0:    .block 1
bcd_out1:    .block 1
bcd_out2:    .block 1
inp0:        .block 1
inp1:        .block 1

song_no:     .block 1 ;current song
play_tune:   .block 1 ;playing tune (actually playing)
play_song:   .block 1 ;playing song

last_tune:   .block 1
tune_no2:    .block 1 ;current tune (on display)
load_add:    .block 2
init_add:    .block 2
play_add:    .block 2
name:        .block 32
auth:        .block 32
speed:       .block 2
bank_adds:   .block 8
total_page:  .block 2
tune_no:     .block 1

temp:        .block 4

sum0:        .block 1
sum1:        .block 1

spect:       .block 20
spec_old:    .block 6
spec_tmr:    .block 3
spec_tmp:    .block 3

song_buf:    .block 128
song_ictr:   .block 1
song_lctr:   .block 1
pcm_ctr:     .block 1
pcm_trip:    .block 1


 .org 05000h    


lcd_write:   .equ 05ff4h
timer_lo:    .equ 05ff0h
timer_hi:    .equ 05ff1h
reset_irq:   .equ 05ff6h
mlock_set:   .equ 05ff3h
mlock_rst:   .equ 05ff2h
inputs:      .equ 05ff7h
card_in:     .equ 05ff6h
bank_addr:   .equ 05ff8h
card_out:    .equ 04016h


bcd_page:    .equ 04e00h


start:       lda #songno
             sta song_no
             lda #tuneno
             sta tune_no
             
re_start:    sei
             cld
             ldx #0ffh
             txs

             lda #0c0h
             sta 04017h
             
             
             ldx #13h
             lda #0
           
cl_lp:       sta 04000h,x
             dex
             bne cl_lp
             sta 04015h



             lda #080h
             jsr lcd_ins
             lda #03bh
             jsr lcd_ins
             lda #00ch
             jsr lcd_ins
             lda #001h
             jsr lcd_ins    ;init LCD
             

             
             jsr cust_disp
             

             lda #1
             sta song_ictr
             sta song_lctr

       ;      sta 05ff8h
       ;      lda #1
       ;      sta 05ff9h
       ;      lda #2
       ;      sta 05ffah
       ;      lda #3
       ;      sta 05ffbh
       ;      lda #4
       ;      sta 05ffch
       ;      lda #5
       ;      sta 05ffdh
       ;      lda #6
       ;      sta 05ffeh
       ;      lda #7
       ;      sta 05fffh
             
          ;   sta mlock_set

         ;    lda #00
         ;    sta card_add
         ;    lda #00h
         ;    sta card_add+1
          ;   lda #0
          ;   sta zp_add
          ;   lda #080h
          ;   sta zp_add+1

big_ld:   ;   jsr card_read
          ;   ldy #0

bgh:      ;   lda card_buf,y
          ;   sta (zp_add),y
          ;   iny
          ;   cpy #080h
          ;   bne bgh
          ;   lda #080h
          ;   clc
          ;   adc zp_add
          ;   sta zp_add
          ;   lda #0
          ;   adc zp_add+1
          ;   sta zp_add+1
          ;   inc card_add
          ;   lda #0c2h
          ;   cmp card_add
          ;   bne big_ld

          ;   sta mlock_rst

             
          ;   lda tuneno
          ;   jsr 08800h

          ;   lda #'B'
          ;   bcs *+4
          ;   lda #'G'
          ;   jsr lcd_dat
             
          ;   lda card_buf
          ;   jsr sho_hex
          ;   lda card_buf+1
          ;   jsr sho_hex
          ;   lda card_buf+2
          ;   jsr sho_hex
          ;   lda card_buf+3
          ;   jsr sho_hex
          ;   lda card_buf+4
          ;   jsr sho_hex
          ;   lda card_buf+5
          ;   jsr sho_hex
          ;   lda card_buf+6
          ;   jsr sho_hex
          ;   lda card_buf+7
          ;   jsr sho_hex

;bbb: jmp bbb
             
             jsr load_info  ;get info
             jsr load_data  ;load tune
             

             jsr init_song  ;init tune



dead:        lda inputs
             eor #0ffh
             and #03
             bne dead
             
dead2:       lda inputs
             eor #0ffh
             and #03
             beq dead2
             ror a
             bcs inctune3
             inc song_no
             lda max_songs
             cmp song_no
             bne no_rest
             lda #0
             sta song_no

no_rest:     lda #0
             sta tune_no
             jmp re_start


inctune3:    inc tune_no
             lda last_tune
             cmp tune_no
             bne no_rst
             lda #0
             sta tune_no
             
no_rst:      jsr init_song
             
             jmp dead
             

IRQ:         pha
             tya
             pha
             txa
             pha
             
             ldy #0
             
ui_lp:     

             lda read_add+2,y
             rol a
             rol a
             rol a          ;stick lower 3 bits in a
             rol a
             and #07h
             sta spec_tmp
             lda read_add+3,y
             rol a
             rol a
             rol a
             and #038h
             ora spec_tmp   ;get upper 3 bits in position
             tax
             lda read_add+0,y
             and #0fh
          ;   clc
          ;   adc #02h
          ;   cmp #02h
          ;   bne *+4
          ;   lda #0
             sta spec_tmp
             cmp spec_old,y
             bne sp_chg
             txa
             cmp spec_old+1,y
             beq no_specup

sp_chg:      txa
             sta spec_old+1,y
             lda spec_tmp
             sta spec_old,y
             
             lda read_add+3,y
             and #07h
             ora read_add+2,y
             beq no_specup
             
             lda pos_dat,x
             tax
           ;  lda #0fh
            
             lda spec_tmp
             cpy #008h
             bne *+4
             lda #0fh
             sta spect,x
             
no_specup:   iny
             iny
             iny
             iny
             cpy #00ch
             bne ui_lp

             lda #080h
             jsr lcd_ins
             ldy #0
             
sho_spec2:   lda spect,y
             tax
             lda sho_t,x
             jsr lcd_dat
             iny
             cpy #20
             bne sho_spec2

             lda #0c0h
             jsr lcd_ins
             ldy #0

sho_spec:    lda spect,y
             tax
             lda sho_b,x
             jsr lcd_dat
             iny
             cpy #20
             bne sho_spec
             

             dec spec_tmr
             bne no_spec
             lda #02
             sta spec_tmr
             ldx #19

upd_spec2:   lda #0
             cmp spect,x
             beq *+5
             dec spect,x
             dex
             bpl upd_spec2

             
no_spec:     lda #7
             dec song_lctr
             bne no_ssctr
             sta song_lctr

             lda #094h
             jsr lcd_ins
             
             
             ldx song_ictr
             lda song_buf,x
             bne *+7
             ldx #0
             stx song_ictr
             ldy #20

sb_shold:    lda song_buf,x
             bne *+4
             ldx #0
             lda song_buf,x
             jsr lcd_dat
             inx
             dey
             bne sb_shold
             inc song_ictr
             
             

             
no_ssctr:             
             
             
             sta reset_irq  ;reset IRQ latch

             lda #(back_here2-1 >> 8)
             pha
             lda #(back_here2-1 & 0ffh)
             pha

             jmp (play_add)
             
back_here2:  lda #0d4h
             jsr lcd_ins
             lda #0a5h
             jsr lcd_dat

             lda 04010h
             and #00fh
             sec
             sbc #6
             bpl *+4
             lda #0        ;if 0-5, set to 6
             pha
             cmp #5
             bcs char_2
             lda #' '
             jsr lcd_dat
             lda #00dh
             jsr lcd_dat
             jmp c2_rst

char_2:      pla
             sec
             sbc #5
             pha
             lda #00dh
             jsr lcd_dat
             lda #' '
             jsr lcd_dat

c2_rst:      pla             
             tay
             lda #0a5h
             jsr lcd_dat
             lda #040h+40
             jsr lcd_ins
             ldx #0        ;start count
             lda 4015h
             and #010h
             bne *+4
             ldy #5

c2_lp:       lda pcm_bit,y             
             jsr lcd_dat
             inx
             cpx #8
             bne c2_lp

             lda #080h
             jsr lcd_ins

             pla
             tax
             pla
             tay
             pla
NMI:         rti

                 
pcm_bit:     .db 001h,002h,004h,008h,010h,000h

sho_t:       .db 020h,020h,020h,020h,020h,020h,020h,020h

sho_b:       .db 020h,05fh,008h,009h,00ah,00bh,00ch,014h
             .db 014h,014h,014h,014h,014h,014h,014h,014h




init_song:   sei
             lda #060h
             sta zp_add+1
             lda #00h
             sta zp_add
             tay

cp_lp9:      sta (zp_add),y
             iny
             bne cp_lp9
             inc zp_add+1
             bit zp_add+1
             bpl cp_lp9      ;clear 6000-7fff
             
             
             
             lda #0
             sta pcm_trip
             ldx #0

             
clr_zpl:     sta 00000h,x
             sta 00200h,x
             sta 00300h,x
             sta 00400h,x
             sta 00500h,x
             sta 00600h,x
             sta 00700h,x
             dex
             bne clr_zpl
             ldx #0e0h

clr_zpl2:    sta 00100h,x
             dex
             cpx #0ffh
             bne clr_zpl2


             lda #08
             sta pcm_ctr

             lda load_add+1
             ror a
             ror a
             ror a
             ror a
             and #007h
             tax
             ldy #0

cd_bank:     tya
             sta bank_addr,x
             iny
             inx
             cpx #8
             bne cd_bank

             ldx #7
             lda #00h

ld_banks2:   ora bank_adds,x
             dex
             bpl ld_banks2
             ora #00h
             beq not_banked
             
             ldx #7
             
ld_banks:    lda bank_adds,x
             sta bank_addr,x
             stx x_temp
             jsr sho_hex
             ldx x_temp
             dex
             bpl ld_banks


             
not_banked:  lda song_no
             sta inp0
             lda #0
             sta inp1
             jsr conv_bcd
             
             ldx #0
             lda bcd_out1
             and #0fh
             beq no_p1
             ora #030h
             sta song_buf,x
             inx
             lda bcd_out2
             ror a
             ror a
             ror a
             ror a
             and #00fh
             jmp no_p3
             
no_p1:       lda bcd_out2
             ror a
             ror a
             ror a
             ror a
             and #00fh
             beq no_p2
             
no_p3:       ora #030h
             sta song_buf,x
             inx
             
no_p2:       lda bcd_out2
             and #00fh
             ora #030h
             sta song_buf,x
             inx
             lda #'.'
             sta song_buf,x
             inx
             lda #' '
             sta song_buf,x
             inx
             ldy #0

l_loop3:     lda name,y
             sta song_buf,x
             beq no_more
             inx
             iny
             cpy #32
             bne l_loop3

no_more:     lda #' '
             sta song_buf,x
             inx
             lda #08eh
             sta song_buf,x
             inx
             lda #' '
             sta song_buf,x
             inx
             ldy #0

l_loop4:     lda auth,y
             sta song_buf,x
             beq no_more3
             inx
             iny
             cpy #32
             bne l_loop4


no_more3:    lda #' '
             sta song_buf,x
             inx
             lda #0a5h
             sta song_buf,x
             inx
             lda #096h
             sta song_buf,x
             inx
             lda #0a5h
             sta song_buf,x
             inx
             lda #' '
             sta song_buf,x
             inx
             lda #0
             sta song_buf,x

             lda #(back_here-1 >> 8)
             pha
             lda #(back_here-1 & 0ffh)
             pha
             lda tune_no
             jmp (init_add)
             
back_here:   lda #'I'
             jsr lcd_dat
             
             lda #00fh
             sta 04015h
             
             lda #041h  ;speed
             sta mul3
             lda #01ah  ;speed+1
             sta mul2
             jsr fix_time

             sta reset_irq
             cli
             rts


load_info:   lda song_no
             sta temp
             lda #0
             sta temp+1
             clc
             rol temp
             rol temp+1
             lda #8
             adc temp
             sta temp
             lda #0
             adc temp+1
             sta temp+1    ;adjust pointer for byte offset into card area
             lda temp
             rol a
             rol temp+1    ;get bank # into temp1 by rotating left
             lda #07fh
             and temp      ;temp holds byte address
             sta temp

            lda #' '
            jsr lcd_dat

             lda temp+1
             sta card_add  
             lda #00h
             sta card_add+1  ;set card address
             jsr card_read   ;get card data
             ldx temp
             lda card_buf,x
             sta temp+2
             lda card_buf+1,x
             sta temp+3       ;store start bank
             inx
             inx
             cpx #128    
             bne no_prob
             inc temp+1
             lda temp+1
             sta card_add
             jsr card_read
             ldx #0

no_prob:     lda card_buf,x
             sta total_page
             lda card_buf+1,x
             sta total_page+1  ;store end bank
             lda temp+2
             sta card_add
             lda temp+3
             sta card_add+1
             jsr card_read     ;get NSF header

             ldx #39+32
             
l_loop1:     lda card_buf+6,x
             sta last_tune,x
             dex
             bpl l_loop1
             
             ldx #9
             
l_loop2:     lda card_buf+06eh,x
             sta speed,x
             dex
             bpl l_loop2         ;load in info to RAM for use
             
             rts


load_data:   sei
             inc card_add
             bne no_carry
             inc card_add+1

no_carry:    sta mlock_set  ;enable data write
             lda #0
             sta temp       ;current bank #
             lda total_page
             sec
             sbc card_add
             sta temp+2
             lda total_page+1
             sbc card_add+1
             sta temp+3      ;store # of pages remaining
             lda load_add
             sta zp_add
             lda load_add+1
             and #0fh
             ora #080h
             sta zp_add+1      ;store load address (8000-8fff)

         ;    lda #(card_buf & 0ffh)
         ;    sta zp_add2
         ;    lda #(card_buf >> 8)
         ;    sta zp_add2+1
             ldx temp
             stx bank_addr
             inx
             stx bank_addr+1   ;store bank #'s


ld_loop:     jsr card_read     ;get 128 bytes
             ldy #07fh

ld_loop2:    lda card_buf,y
             sta (zp_add),y
             clc
             adc sum0
             sta sum0
             lda #0
             adc sum1
             sta sum1
             dey
             bpl ld_loop2     ;load it in
             inc card_add
             bne no_carry2
             inc card_add+1   ;inc card address

no_carry2:   lda #080h
             clc
             adc zp_add
             sta zp_add
             lda #000h
             adc zp_add+1
             sta zp_add+1    ;add 80h to address pointer
             cmp #090h
             bne no_bankinc  ;see if bank rolled over
             lda #080h
             sta zp_add+1    
             inc temp        ;if so, reset pointer & inc bank ctr
             ldx temp
             stx bank_addr
             inx
             stx bank_addr+1  ;store bank #'s
             
no_bankinc:  lda #2
             jsr lcd_ins
             lda card_add
             and #3
             tax
             lda wt_flip,x
             jsr lcd_dat
             lda #080h
             jsr lcd_dat
             
             lda #0ffh
             dec temp+2
             cmp temp+2
             bne ld_loop
             dec temp+3
             cmp temp+3
             bne ld_loop
             sta mlock_rst
             
             rts



wt_flip:     .db 02dh,08ch,07ch,02fh

lcd_dat:     bit lcd_write
             bmi lcd_dat
             sta lcd_write+1
             rts

lcd_ins:     bit lcd_write
             bmi lcd_ins
             sta lcd_write
             rts


sho_hex:     pha
             ror a
             ror a
             ror a
             ror a
             jsr s_h1
             pla

s_h1:        and #00fh
             tax
             lda hex_tab,x
             jmp lcd_dat



hex_tab:     .db "0123456789ABCDEF"


;timer value gets stored into mul2 and mul3

fix_time:    ldx #16      ;iteration counter
             lda #0
             sta mul0
             sta mul1     ;clear product register

m_loop:      clc
             rol mul0
             rol mul1
             rol mul2
             rol mul3     ;rotate product & multiplicand
             bcc no_mult
             clc
             lda #017h
             adc mul0
             sta mul0
             lda #0e5h
             adc mul1
             sta mul1
             lda #000h    ;0e517h is the "magic number" for conversion
             adc mul2
             sta mul2     ;add multiplicand to product

no_mult:     dex
             bne m_loop
             lda mul2
             sta timer_lo
             lda mul3
             sta timer_hi  ;store result
             rts

;Dout 0
;CLK  1
;SEL  2  4016h
;
;Din  0
;ACK  1  5ff7h









card_read:   ldx #0
             
ci_wrt:      txa
             clc
             adc #05ah
             sta card_img,x
             inx
             cpx #4
             bne ci_wrt
             lda #'R'
             sta card_img+1
             
             
             lda #000h
             sta card_img+4
             sta card_out    ;CLK, SEL, Dout all high
             
             jsr ms_16       ;wait 16ms
             
             lda #004h       ;lower select to enable card
             sta card_out
             
             lda #081h
             jsr send_byte   ;send 1st control byte
             bcc *+3
             rts
             lda #052h
             jsr send_byte   ;2nd control byte
             bcc *+3
             rts
             ldx #0

getd_loop:   ldy g_dat,x     ;get address
             lda 01000h,y         ;get variable
             stx x_temp
             jsr send_byte   ;send 8 header bytes
             bcc *+3
             rts
             ldx x_temp
             ldy g_comp,x
             cmp 01000h,y         ;compare against desired result
             bne gd_err
             inx
             cpx #8
             bne getd_loop   ;do 8 bytes worth
             lda card_add
             eor card_add+1
             sta card_xor    ;init card_xor reg
             ldx #000h

get_dat:     stx x_temp
             lda #000h
             jsr send_byte
             bcc *+3
             rts
             ldx x_temp
             sta card_buf,x  ;get 129 bytes from card
             cpx #128
             beq next_pt     ;skip last XOR
             eor card_xor
             sta card_xor    ;do the XOR check thingy
             inx
             bne get_dat     ;always true
             
next_pt:     lda #000h
             jsr send_bytel      
             ldx x_temp
             sta card_buf+1,x  ;store final value
             lda #000h
             sta card_out    ;pull all outputs high
             clc             ;OK flag
             rts             ;done


;ugh oh, got an error

gd_err:      jsr sho_hex
             lda #000h
             sta card_out
             sec            ;not OK flag
             rts

g_dat:       .db (card_img+4) & 0ffh,(card_img+4) & 0ffh
             .db (card_add+1) & 0ffh,(card_add+0) & 0ffh
             .db (card_img+4) & 0ffh,(card_img+4) & 0ffh
             .db (card_img+4) & 0ffh,(card_img+4) & 0ffh

g_comp:      .db (card_img+0) & 0ffh,(card_img+3) & 0ffh
             .db (card_img+4) & 0ffh,(card_add+1) & 0ffh
             .db (card_img+2) & 0ffh,(card_img+3) & 0ffh
             .db (card_add+1) & 0ffh,(card_add+0) & 0ffh
            





sb_xor:      tax
             eor card_xor
             sta card_xor
             txa
             jmp send_byte
             
gb_xor:      jsr send_byte
             tax
             eor card_xor
             sta card_xor
             txa
             rts

send_byte:   sta card_temp
             ldx #4
             
sb_loop:     lda #007h
             clc
             ror card_temp
             bcc no_set
             lda #006h
             
no_set:      sta card_out     ;set/clear output bit & pull clk low
             nop
             bit card_in
             clc
             bvc no_ll
             sec

no_ll:       ror card_temp2
             and #005h
             sta card_out     ;set clock to lock in value
             dex
             bne sb_loop

             lda inputs    ;reset latch
             ldx #4

sb_loop2:    lda #007h
             clc
             ror card_temp
             bcc no_set2
             lda #006h
             
no_set2:     sta card_out     ;set/clear output bit & pull clk low
             bit card_in
             clc
             bvc no_ll2
             sec

no_ll2:      ror card_temp2
             and #005h
             sta card_out     ;set clock to lock in value
             dex
             bne sb_loop2
             ldx #0
             ldy #0
             
card_dl:     bit card_in
             bpl no_lwt
             dex
             bne card_dl
             dey
             bne card_dl
             sec              ;not OK flag
             lda card_temp2
             rts

no_lwt:      lda card_temp2
             clc              ;OK flag
             rts


send_bytel:  sta card_temp
             ldx #8
             
sb_loopl:    lda #007h
             clc
             ror card_temp
             bcc no_setl
             lda #006h
             
no_setl:     sta card_out     ;set/clear output bit & pull clk low
             nop
             bit card_in
             clc
             bvc no_lll
             sec

no_lll:      ror card_temp2
             and #005h
             sta card_out     ;set clock to lock in value
             dex
             bne sb_loopl
             lda card_temp2
             clc              ;OK flag
             rts              ;no ACK check
             

ms_16:       ldx #19
             
ff:          ldy #0h      ;3  \

gh:          dey          ;2  |1542 cycles
             nop          ;2  |
             bne gh       ;2  |
             dex          ;2  |
             bne ff       ;2  /
             rts
             

cust_disp:   lda #(cd_dat & 0ffh)
             sta zp_add
             lda #(cd_dat >> 8)
             sta zp_add+1

             lda #040h
             jsr lcd_ins
             ldx #5     ;# of chars to load

cd_loop1:    ldy #0     ;# of lines per char

cd_loop2:    lda (zp_add),y
             jsr lcd_dat
             iny
             cpy #8
             bne cd_loop2
             inc zp_add
             bne *+4
             inc zp_add+1
             dex
             bne cd_loop1
             lda #080h
             jsr lcd_ins
             rts


conv_bcd:  ldx #16
           lda #0
           sta bcd_out0
           sta bcd_out1
           sta bcd_out2    ;clear result regs

b2bcd:     clc
           rol inp0
           rol inp1
           rol bcd_out2
           rol bcd_out1
           rol bcd_out0    ;rotate results
           dex
           beq bc_done
           ldy #(bcd_out2 & 0ffh)
           jsr bcdfix
           ldy #(bcd_out1 & 0ffh)
           jsr bcdfix
           ldy #(bcd_out0 & 0ffh)
           jsr bcdfix
           jmp b2bcd

bcdfix:    lda bcd_page,y
           clc
           adc #003h
           and #008h
           beq bcd_f2
           lda bcd_page,y
           clc
           adc #003h
           sta bcd_page,y

bcd_f2:    lda bcd_page,y
           clc
           adc #030h
           and #080h
           beq bc_done
           lda bcd_page,y
           clc
           adc #030h
           sta bcd_page,y

bc_done:   rts


cd_dat:      .db 00h,00h,00h,00h,00h
             .db 0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
             

pos_dat:     .db 00h,01h,02h,03h,04h,05h,05h,06h
             .db 07h,07h,08h,08h,09h,09h,09h,0Ah
             .db 0Ah,0Bh,0Bh,0Bh,0Ch,0Ch,0Ch,0Ch
             .db 0Dh,0Dh,0Dh,0Dh,0Eh,0Eh,0Eh,0Eh
             .db 0Fh,0Fh,0Fh,0Fh,0Fh,010h,010h,010h
             .db 010h,010h,010h,011h,011h,011h,011h,011h
             .db 011h,012h,012h,012h,012h,012h,012h,012h
             .db 013h,013h,013h,013h,013h,013h,013h,013h



 .fill 05ffah-*,0ffh

 .dw NMI
 .dw start
 .dw IRQ


;card_wrt:    lda #000h
;             sta card_out    ;CLK, SEL, Dout all high
;             
;             jsr ms_16       ;wait 16ms
;             
;             lda #004h       ;lower select to enable card
;             sta card_out
;             
;             lda #081h
;             jsr send_byte
;             lda #057h
;             jsr send_byte
;             lda #000h
;             jsr send_byte
;             cmp #05ah
;             bne cw_err
;             lda #000h
;             jsr send_byte
;             cmp #05dh
;             bne cw_err
;             lda card_add+1
;             jsr send_byte
;             cmp #000h
;             bne cw_err
;             lda card_add
;             jsr send_byte
;             cmp card_add+1
;             bne cw_err
;             eor card_add
;             sta card_xor
;             ldx #0
;             
;g_loop:      stx x_temp
;             lda card_buf,x
;             jsr send_byte
;             bcc *+3
;             rts
;             ldx x_temp
;             lda card_buf,x
;             eor card_xor
;             sta card_xor
;             inx
;             cpx #128
;             bne g_loop
;             
;             lda card_xor
;             jsr send_byte
;             lda #000h
;             jsr send_byte
;             cmp #05ch
;             bne cw_err
;             lda #000h
;             jsr send_byte
;             cmp #05dh
;             bne cw_err
;             lda #000h
;             jsr send_bytel
;             cmp #'G'
;             bne cw_err
;             lda #000h
;             sta card_out
;             clc
;             rts
;
;cw_err:      lda #000h
;             sta card_out
;             sec
;             rts

 .end
